> For the complete documentation index, see [llms.txt](https://docs.caf.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.caf.io/caf-sdk/ios/standalone-modules/cafsmartauth/lifecycle.md).

# SDK Lifecycle

## CafVerifyPolicyListener

The `CafVerifyPolicyListener` closure handles key events during the SDK's authentication:

| Event                                                                     | Description                                                                            |
| ------------------------------------------------------------------------- | -------------------------------------------------------------------------------------- |
| `onCanceled(failure: CafSmartAuthError)`                                  | Triggered when the user cancels the process, with error details provided in `failure`. |
| `onError(failure: CafSmartAuthError)`                                     | Called on SDK failure, with error details provided in `failure`.                       |
| `onPending(isAuthorized: Bool, attestation: String)`                      | Called when the SDK is waiting for a result.                                           |
| `onLoaded()`                                                              | Triggered when the SDK is ready.                                                       |
| `onLoading()`                                                             | Indicates the SDK is initializing.                                                     |
| `onSuccess(isAuthorized: Bool, attemptId: String?, attestation: String?)` | Called upon successful detection, with the result provided.                            |

### Example

```swift
private func setupListener() -> CafVerifyPolicyListener {
    return { result in
        switch result {
        case .onSuccess(let response):
            print("CafVerifyPolicyListener.onSuccess isAuthorized: \(response.isAuthorized)")
            print("CafVerifyPolicyListener.onSuccess attestation: \(response.attestation)")
        
        case .onPending(let response):
            print("CafVerifyPolicyListener.onPending isAuthorized: \(response.isAuthorized)")
            print("CafVerifyPolicyListener.onPending attestation: \(response.attestation)")
        
        case .onError(let error):
            print("CafVerifyPolicyListener.onError failure: \(error.localizedDescription)")

        case .onCanceled(let error):
            print("CafVerifyPolicyListener.onCanceled failure: \(error.localizedDescription)")
        
        case .onLoading(let isLoading):
            print("CafVerifyPolicyListener.onLoading isLoading: \(isLoading)")
        
        case .onLoaded(let isLoaded):
            print("CafVerifyPolicyListener.onLoaded isLoaded: \(isLoaded)")
        }
    }
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.caf.io/caf-sdk/ios/standalone-modules/cafsmartauth/lifecycle.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
